<?php

// "AMP-Cloud.de"-Plugin VERSION 3.6 ------------------------------------------------------------------------------------------------------

	// Description / Beschreibung ---------------------------------------------------------------------------------------------------------
	/*
		Dieses AMP-Plugin erstellt automatisiert Accelerated-Mobile-Pages für Deine Website. Dazu nutzt dieses AMP-Plugin den
		AMP-HTML-Generator-Dienst / AMP-Online-Generaror-Dienst von amp-cloud.de
		
		Dieses Script erhält über den URL-Paratemer "url=" eine encodierte URL der Unterseite zu der eine AMP-Version genriert werden
		soll. Diese URL wird vom Script decodiert und an den AMP-Online-Generaror von amp-cloud.de gesendet - amp-cloud.de generiert eine
		aus dem unter dieser URL zu findenden HTML-Code eine AMP-HTML-Variante und sendet diesen AMP-Quellcode an dieses Script zurück,
		womit es zur Ausgabe ausgegeben wird.
		
		Beim ersten Aufruf Deiner AMP-Version kann es unter Umständen etwas dauern, da das erste Generieren etwas mehr Zeit in Anspruch
		nimmt. Das kann auch nach Änderungen an Deinem Ursprungsquellcode vorkommen. Wundere Dich also nicht und bringe etwas Geduld mit :)
		
		Nachdem das erste Mal eine AMP-Seite für die jeweilige Unterseite erstellt wurde, speichert dieses Script eine Datei mit dem AMPHTML-Code
		in einem Unterordner (/temp-amp/). Beim nächtsten Aufruf der AMP-Seite wird die Seite direkt aus diesem Ordner geladen, und nicht erneut
		an den AMP-Online-Generaror von amp-cloud.de gesendet. Damit wird die Seite nicht jedes Mal neu generiert und kann somit schneller geladen
		werden. Ist die Version im Ordner älter als 1 Stunde, wird erneut eine Anfrage an den AMP-Online-Generaror von amp-cloud.de gesendet
		und aktualisiert. Hierbei wird die Version gespeichert, die amp-cloud.de zurückliefert. Unter Umständen liefert auch amp-cloud.de
		zu diesem Zeitpunkt nur die AMP-Version zurück, die dort im Cache vorhanden ist. amp-cloud.de hat einen eigenen, gesonderten Zyklus
		zu wann die AMP-Seite neu generiert und somit aktualisiert wird. D.h. Änderungen auf Deiner Seite können unter Umständen eine Weile dauern,
		bis diese auch in der AMP-Version aktualisiert sind.
		
		AMP-Seiten, die über 7 Tage nicht mehr aufgerufen wurden, werden aus dem Unterordner (/temp-amp/) gelöscht und beim nächsten Aufruf
		dann wieder neu generiert. Das Löschen erfolgt sobald irgendeine AMP-Seite über dieses Script aufgerufen wird, jedoch nur einmalig
		innerhalb 24 Stunden.
		
		Verfügt die Website, auf der dieses Script verwendet wird, eine ads.txt, wird dieses Script die Publisher-ID des Google-Kontos
		von amp-cloud.de hinzufügen.
		
		Beachte bitte, dass die Ladezeiten der AMP-Versionen über Deine Domain/Deinen Server nicht den realen Ladezeiten bei Deinen Nutzern
		entspricht, da bei einem Aufruf über die Suchmaschine die AMP-Seiten direkt vom Suchmaschinen-Server statt von Deinem direkten Server
		aufgerufen werden, der in der Regel deutlich schneller ist!
		Für mehr Informationen dazu schaue Dich im Web zum Thema "Google AMP Cache" um.
		
		Gefällt Dir das Plugin?
		
		Zeige Dich erkenntlich und unterstütze das Projekt mit einer freiwilligen Spende über folgenden Link:
		https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=YXREU35KSAHUC
	*/
	
	
	// Installation -----------------------------------------------------------------------------------------------------------------------
	/*
		To install this Plugin and make it work follow the instructions at:
		https://www.amp-cloud.de/php-amp-plugin.php
		
		Zur Installation des Plugins folge der Anleitung unter:
		https://www.amp-cloud.de/php-amp-plugin.php
	*/

	
	// License / Lizenz -------------------------------------------------------------------------------------------------------------------
	
		/*
			License		: GPL
			License URI	: https://www.gnu.org/licenses/gpl
		*/

		
	// Important instructions -------------------------------------------------------------------------------------------------------------
	
		/*
			"AMP-Cloud.de"-Plugin is free software: you can redistribute it and/or modify
			it under the terms of the GNU General Public License as published by
			the Free Software Foundation, either version 3 of the License, or
			any later version.
			 
			"AMP-Cloud.de"-Plugin is distributed in the hope that it will be useful,
			but WITHOUT ANY WARRANTY; without even the implied warranty of
			MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
			GNU General Public License for more details.
			 
			You should have received a copy of the GNU General Public License
			along with "AMP-Cloud.de"-Plugin. If not, see https://www.gnu.org/licenses/gpl
		*/
		
		
	// Wichtige Hinweise ------------------------------------------------------------------------------------------------------------------
	
		/*
			Dieses Plugin ist freie, kostenlose Software. Du kannst es für Deinen eigenen Gebrauch für
			private und auch kommerzielle Zwecke verändern und verwenden entsprechend der der Lizenz unter
			https://www.gnu.org/licenses/gpl
			
			Dieses AMP-Plugin wird bereitgestellt in der Hoffnung Dir die Erstellung von AMP-Versionen für
			Deine Website zu vereinfachen, die Verwendung erfolgt jedoch auf Deine eigene Verantwortung und Gefahr.
			Dieses AMP-Plugin leistet keine Garantie und keine Gewährleistung auf eine fehlerfreie Funktionalität
			und Kompatibilität mit Deiner Website und Deinen Systemumgebungen!
			
			Jedes Ergebnis, welches über dieses AMP-Plugin ausgegeben wird erfolgt in Deinem eigenen Namen und auf
			Deine eigene Gefahr.
		*/
		
		
	// Editor / Herausgeber ---------------------------------------------------------------------------------------------------------------
	
		/*
			This AMP-Plugin is freeware and created by Björn Staven for amp-cloud.de
			
			Dieses AMP-Plugin ist Freeware und wurde für amp-cloud.de entwickelt von Björn Staven
			
			Facebook		: https://www.facebook.com/AMPCloud.de
			WordPress		: https://de.wordpress.org/plugins/wp-amp-it-up/
		*/
		
		
	// Do you like this Plugin? / Gefällt Dir das Plugin? ---------------------------------------------------------------------------------
	
		/*
			Show appreciation or gratitude and support this project with a voluntary donation following this link:
			https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=YXREU35KSAHUC
		
			Zeige Dich erkenntlich und unterstütze das Projekt mit einer freiwilligen Spende über folgenden Link:
			https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=YXREU35KSAHUC
		*/


// GZIP-Komprimierung aktivieren ----------------------------------------------------------------------------------------------------------

	ob_start("ob_gzhandler");

	
// Session starten ------------------------------------------------------------------------------------------------------------------------
	
	session_start();
	
	
// Funktionen -----------------------------------------------------------------------------------------------------------------------------

	// URL Scheme auslesen --------------------------------------------------------------
	
		function amp_cloud_getSCHEME()
		{
			if(!empty($_SERVER["HTTPS"]))
			{
				$urlSCHEME	= "https://";
			}
			else
			{
				$urlSCHEME	= "http://";
			}
			
			
			return "".$urlSCHEME."";
		}

		
	// Query aufräumen - KD URL ---------------------------------------------------------
	
		function sortQUERY($queryIST)
		{
			if(!empty($queryIST))
			{
				// Query splitten
				
					parse_str($queryIST, $output_ist);
						
						
				// Leere Parameter entfernen
				
					$output_ist	= array_filter($output_ist);
					$output_ist	= array_merge($output_ist);

					
				// Doppelte Parameter entfernen
					
					array_unique($output_ist);
					
					
				// Query sortieren

					ksort($output_ist);
					
					
				// Query-Ausgabe setzen
				
					$queryNEU		= http_build_query($output_ist);
			}
			else
			{
					$queryNEU			= "".$queryIST."";
			}
			
	
			// Rückgabe
			
				return "".$queryNEU."" ;
		}

		
	// URL aufräumen --------------------------------------------------------------------
	
		function sortURL($urlIST)
		{
			if(!empty($urlIST))
			{
				// URLs parsen 
				
					$urlTEILE_ist				= parse_url("".$urlIST."");
				
				
				// URL Query aufräumen
				
					if(isset($urlTEILE_ist["query"]))
					{
						$urlTEILE_ist["query"]	= sortQUERY("".$urlTEILE_ist["query"]."");
					}
					

				// URL wieder zusammensetzen --------------------------------------------------------------------------------------
						
					$scheme_ist		= isset($urlTEILE_ist["scheme"])	? "".strtolower("".$urlTEILE_ist["scheme"]."")."://"	: ""; 
					$host_ist		= isset($urlTEILE_ist["host"])		? "".strtolower("".$urlTEILE_ist["host"]."").""			: ""; 
					$port_ist		= isset($urlTEILE_ist["port"])		? ":".$urlTEILE_ist["port"].""							: ""; 
					$user_ist		= isset($urlTEILE_ist["user"])		? "".$urlTEILE_ist["user"].""							: ""; 
					$pass_ist		= isset($urlTEILE_ist["pass"])		? ":".$urlTEILE_ist["pass"].""							: ""; 
					$pass_ist		= ($user_ist || $pass_ist)			? "".$pass_ist."@"										: ""; 
					$path_ist		= isset($urlTEILE_ist["path"])		? "".$urlTEILE_ist["path"].""							: ""; 
					$query_ist		= isset($urlTEILE_ist["query"])		? "?".$urlTEILE_ist["query"].""							: ""; 
					$fragment_ist	= isset($urlTEILE_ist["fragment"])	? "#".$urlTEILE_ist["fragment"].""						: "";
					
				// ----------------------------------------------------------------------------------------------------------------
				
					$url_neu		= "".$scheme_ist."".$user_ist."".$pass_ist."".$host_ist."".$port_ist."".$path_ist."".$query_ist."".$fragment_ist."";
					$url_neu		= preg_replace("/(\s)*((\?|\&)*(\=)*(\s)?)+$/i", "", "".$url_neu."");
			}
			else
			{
					$url_neu		= false ;
			}
				
				
			// Rückgabe
			
				return $url_neu ;
		}


	// Aktuelle URL auslesen ------------------------------------------------------------

		function amp_cloud_get_urlaktuellos()
		{
			$urlSCHEME			= "".amp_cloud_getSCHEME()."";
		
		
			$urlaktuell 		= "".$urlSCHEME."".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]."";
			$url_splitt			= parse_url($urlaktuell);
		
		
			if(!empty($url_splitt["user"]) AND !empty($url_splitt["pass"]))
			{
				$urluser		= "".$url_splitt["user"].":".$url_splitt["pass"]."@";
			}
			else
			{
				$urluser		= "";
			}	
				
				
			$urlaktuellos		= "".$url_splitt["scheme"]."://".$urluser."".strtolower($url_splitt["host"])."".$url_splitt["path"]."";
			

			return trim("".$urlaktuellos."") ;
		}

	
		function amp_cloud_get_urlaktuell()
		{
			if(!empty($_SERVER["QUERY_STRING"]))
			{
				$urlquery		= "?".sortQUERY($_SERVER["QUERY_STRING"])."";
			}
			else
			{
				$urlquery		= "".sortQUERY($_SERVER["QUERY_STRING"])."";
			}

				$urlaktuell 	= "".amp_cloud_get_urlaktuellos().$urlquery."";
				
				
			return	trim("".$urlaktuell."");		
		}
		
		
	// Ordner anlegen -------------------------------------------------------------------
	
		function set_dir($fullpath)
		{
			// Laufzeit setzen
				
				set_time_limit(60);
				

			// Windows konform gestalten
			
				$fullpath		= str_replace("\\", "/", "".$fullpath."");


			// Order anlegen
				
				if(!file_exists("".$fullpath.""))
				{
					return mkdir("".$fullpath."", 0755, true);
				}
				else
				{
					return false ;
				}
		}
		
		
	// Datei aktualisieren --------------------------------------------------------------
	
		function set_datei($speicherort, $inhalt)
		{
			// allow_url_fopen aktivieren
			
				ini_set("allow_url_fopen", true);
	
	
			// Windows konform gestalten
			
				$speicherort		= str_replace("\\", "/", "".$speicherort."");
			
			
			// Datei-Daten zusammenstellen
			
				$dateipath			= "".dirname("".$speicherort."")."";
				$dateiname			= "".$speicherort."";
				
									if(!file_exists("".$dateipath.""))
									{
										set_dir("".$dateipath."");
									}


			// Datei schreiben
									
				$datei		 		= fopen($dateiname,"w+b");
									  fwrite($datei, $inhalt);
									  fclose($datei);
		}


// URL für AMP-Version auslesen -----------------------------------------------------------------------------------------------------------

	$getURL				= urldecode("".$_GET['url']."");
	$getURL				= trim("".$getURL."");
	$getURL				= sortURL("".$getURL."");
	

	if(!empty($getURL))
	{
		// Allgemeine Daten -------------------------------------------------
					
			$amp_cloud_ws_user_agent		= "WordPress Plugin - AMP PHP - ".$_SERVER["HTTP_HOST"]." (+".amp_cloud_get_urlaktuellos().")";
			
		
		// Cache Data -------------------------------------------------------
					
			$urlARTIKEL			= "".$getURL."";
			$urlCACHEfolder		= "".__DIR__."/temp-amp/";
			$urlCACHEdatei		= "".$urlCACHEfolder."".md5("".$urlARTIKEL."").".txt";
			$ccount				= 0 ;
						
						
			// Cache Ordner prüfen/anlegen
				
				checkdir:
				
					$ccount++ ;
					
					if($ccount < 3)
					{
						if(is_dir("".$urlCACHEfolder.""))
						{
							// Status setzen DIR
							
								$amp_status_dir		= true ;
								
								
							// Prüfen, ob Datei im Cache ist
							
								if(file_exists("".$urlCACHEdatei.""))
								{
									// Status setzen DIR
									
										$amp_status_datei	= true ;
									
									
									// Datei-Datum prüfen
									
										$dateiTIME_jetzt	= time();
										$dateiTIME_last		= filemtime("".$urlCACHEdatei."");
										$dateiTIME_diff		= ( 60 * 60 * 1) ; 							// in Sekunden (einmal pro Stunde)
										$dateiTIME_ist		= ( $dateiTIME_jetzt - $dateiTIME_last ) ;
										
										
										if($dateiTIME_ist >= $dateiTIME_diff)
										{
											$amp_status_cache	= false ;
										}
										else
										{
											$amp_status_cache	= true ;
										}
									
								}
								else
								{
											$amp_status_cache	= false ;
								}
						}
						else
						{
							// Status setzen DIR
							
								$amp_status_dir		= false ;
								$amp_status_datei	= false ;
								$amp_status_dtime	= false ;
								$amp_status_cache	= false ;
								
								
							// Cache Ordner anlegen
							
								set_dir("".$urlCACHEfolder."");
								
								
							// Nochmal prüfen
								
								goto checkdir ;
						}
					}
					else
					{
							// Status setzen DIR
							
								$amp_status_dir		= false ;
								$amp_status_datei	= false ;
								$amp_status_dtime	= false ;
								$amp_status_cache	= false ;
					}
								
								
			// Cache Datei ausgeben oder URL neu von amp-cloud.de abrufen
			
				if($amp_status_cache === true)
				{
					// AMP-Cache-Datei ausgeben
					
						echo "".file_get_contents("".$urlCACHEdatei."")."";
				}
				else
				{
					// AMP-Seite von AMP-Cloud.de laden und ausgeben
					
						// amp-cloud.de AMP-HTML-Adresse
			
							$ampcloud_url		= "https://www.amp-cloud.de/amp/amp-plugin-website.php?s=".urlencode("".$urlARTIKEL."")."";
							
							
						// amp-cloud.de Abfrage
				
							ini_set("max_execution_time", 300);
							
							//echo "<hr>".$ampcloud_url."<hr>".$urlARTIKEL."<hr>";
							//exit;
					
								if(function_exists("curl_version"))
								{
									$curl = curl_init();
									curl_setopt($curl, CURLOPT_URL, $ampcloud_url);
									curl_setopt($curl, CURLOPT_RETURNTRANSFER,	true);
									curl_setopt($curl, CURLOPT_FOLLOWLOCATION,	true);
									curl_setopt($curl, CURLOPT_SSL_VERIFYPEER,	0);
									curl_setopt($curl, CURLOPT_SSL_VERIFYHOST,	0);
									curl_setopt($curl, CURLOPT_REFERER,			"".$urlARTIKEL.""); 
									curl_setopt($curl, CURLOPT_USERAGENT,		"".$amp_cloud_ws_user_agent."");
									curl_setopt($curl, CURLOPT_HTTPHEADER,		array('Accept: text/html'));
									$amp_quelltext = curl_exec($curl);
									curl_close($curl);
									
									echo "".$amp_quelltext."";
								}

								if(empty($amp_quelltext))
								{
									$amp_quelltext	= file_get_contents("".$ampcloud_url."");
									echo "".$amp_quelltext."";
								}

								if(empty($amp_quelltext))
								{
									echo "Please try again in a few minutes!";
								}
											
											
						// Aktuelle Version (neu) im Cache speichern
						
							if(	$amp_status_dir === true AND $amp_status_cache === false AND !empty($amp_quelltext))
							{
								// Prüfen, ob Quellcode AMPHTML von amp-cloud.de ist
								
									$searchAMPverification	= stripos("".$amp_quelltext."", "ampcloud-site-verification");
									
									if($searchAMPverification !== false)
									{
										set_datei("".$urlCACHEdatei."", "".$amp_quelltext."");
									}
							}
				}
				
				
		// Alte Cache-Dateien löschen
			
			// Check-Data

				$urlCHECK_absolute	= "".__DIR__."/temp_check_last_cachedatei.txt";
				
				
			// Prüfen wann alte Cache-Dateien zu letzt gecheckt/gelöscht wurden
			
				if(file_exists("".$urlCHECK_absolute.""))
				{
					$zeitJEZTZ		= time();
					$zeitLAST		= trim(file_get_contents("".$urlCHECK_absolute.""));
					$zeitDIFFmax	= ( 60 * 60 * 1 ) ; 				// in Sekunden (jede Stunde)
					//$zeitDIFFmax	= ( 60 * 60 * 24 ) ; 				// in Sekunden (einmal am Tag)
					$zeitDIFFist	= ( $zeitJEZTZ - $zeitLAST ) ;
					
					
					if($zeitDIFFist >= $zeitDIFFmax)
					{
						$delSTATUS	= true ;
					}
					else
					{
						$delSTATUS	= false ;
					}
				}
				else
				{
						$delSTATUS	= true ;
				}

			
			// Alte Cache-Datein löschen
			
				if($delSTATUS === true)
				{
					$cachefiles			= glob("".$urlCACHEfolder."*");
					$cachetime_jetzt	= time();
					$cachetime_diff		= ( 60 * 60 * 24 * 1 ); 		// in Seunden (1 Tag)
					//$cachetime_diff	= ( 60 * 60 * 24 * 7 ); 		// in Seunden (7 Tage)

					foreach($cachefiles AS $cachefileIST)
					{
						if(is_file("".$cachefileIST.""))
						{
							if(	($cachetime_jetzt - filemtime("".$cachefileIST."")) >= $cachetime_diff )
							{
								unlink("".$cachefileIST."");
							}
						}
					}
					
					
					// Aktuelles Prüfdatum setzen
					
						set_datei("".$urlCHECK_absolute."", "".time()."");
				}
					
		
	// Ads.txt prüfen -------------------------------------------------------------------
	
		function amp_cloud_check_adstxt()
		{
			// Check-Data
			
				$urlCHECK_absolute	= "".__DIR__."/temp_check_last_ads.txt";
				$urlADS_absolute	= "".amp_cloud_getSCHEME()."".$_SERVER["HTTP_HOST"]."/ads.txt";
				$searchSTRING		= "pub-6257427840544279,";
				
				
			// Prüfen wann zu letzt gecheckt wurde

				if(file_exists("".$urlCHECK_absolute.""))
				{
					$zeitJEZTZ		= time();
					$zeitLAST		= trim(file_get_contents("".$urlCHECK_absolute.""));
					$zeitDIFFmax	= ( 60 * 60 ) ; // in Sekunden
					$zeitDIFFist	= ( $zeitJEZTZ - $zeitLAST ) ;
					
					
					if($zeitDIFFist >= $zeitDIFFmax)
					{
						$checkSTATUS	= true ;
					}
					else
					{
						$checkSTATUS	= false ;
					}
				}
				else
				{
						$checkSTATUS	= true ;
				}
				
				
			// Ads.txt prüfen
			
				if($checkSTATUS == true)
				{
					// Check-Datum setzen
					
						set_datei("".$urlCHECK_absolute."", "".time()."");
			
			
					// Suche PUB ID
					
						if(file_exists("".$urlADS_absolute.""))
						{
							$adsCONTENT		= file("".$urlADS_absolute."", FILE_SKIP_EMPTY_LINES);
							$adsCONTENT		= array_reverse($adsCONTENT);
							
							
							foreach($adsCONTENT AS $zeile)
							{
								$searchFIND				= stripos("".$zeile."", "".$searchSTRING."");
								
								if($searchFIND != false)
								{
									$searchSTATUS		= true;
									
									
									$searchFIND2		= stripos("".$zeile."", "".$searchSTRING." DIRECT");
									
									if($searchFIND2 != false)
									{
										$searchSTATUS2	= true ;
									}
									else
									{
										$searchSTATUS2	= false ;
									}
									
									
									break ;
								}
								else
								{
									$searchSTATUS	= false ;
									$searchSTATUS2	= false ;
								}
							}
						}
						else
						{
									$searchSTATUS	= false ;
									$searchSTATUS2	= false ;
						}
						
						
					// Speicher freigeben
					
						unset( $adsCONTENT );
					
					
					// Setze PUB ID
					
						if($searchSTATUS == false)
						{
							$zeileADD					= "google.com, ".$searchSTRING." RESELLER, f08c47fec0942fa0";
							
							if(file_exists("".$urlADS_absolute.""))
							{
								$zeileADDTEXT			= "".file_get_contents("".$urlADS_absolute."")."\r\n".$zeileADD."\r\n";
								$zeileADDSTATUS			= set_datei("".$urlADS_absolute."", "".$zeileADDTEXT."");
							}
							else
							{
								$zeileADDTEXT			= "".$zeileADD."\r\n";
								$zeileADDSTATUS			= set_datei("".$urlADS_absolute."", "".$zeileADDTEXT."");
							}
						}
						elseif( $searchSTATUS2 == true )
						{
							// PUB ID ersetzen
							
								$zeileDEL				= "google.com, ".$searchSTRING." DIRECT, f08c47fec0942fa0";
								$zeileADD				= "google.com, ".$searchSTRING." RESELLER, f08c47fec0942fa0";
								
								if(file_exists("".$urlADS_absolute.""))
								{
									$zeileIST			= "".file_get_contents("".$urlADS_absolute."")."";
									
									if( !empty( "".$zeileIST."" ) )
									{
										$zeileADDTEXT		= "".str_ireplace( "".$zeileDEL."" , "".$zeileADD."" , "".$zeileIST."" )."";
										$zeileADDSTATUS		= set_datei("".$urlADS_absolute."", "".$zeileADDTEXT."");
									}
								}
						}
						
						
					// Speicher freigeben
					
						unset( $zeileDEL , $zeileADD , $zeileIST , $zeileADDTEXT , $zeileADDSTATUS , $searchSTRING );
				}	
		}
	
	
		// Ads.txt Prüfung ausführen
		
			amp_cloud_check_adstxt();
	}
	else
	{
		echo "	<center>
					".$_SERVER["HTTP_HOST"]." verwendet das offizielle AMP-Plugin von <a href=\"https://www.amp-cloud.de/php-amp-plugin.php\">amp-cloud.de</a>
					<p>&nbsp;</p>
					Hier geht's zur Startseite:<br>
					<a href=\"".amp_cloud_getSCHEME()."".$_SERVER["HTTP_HOST"]."\">".$_SERVER["HTTP_HOST"]."</a>
				</center>
			";
	}
?>